package jalview.ws.dbsources.das.api;

import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import org.biodas.jdas.client.ConnectionPropertyProviderI;
import org.biodas.jdas.client.threads.MultipleConnectionPropertyProviderI;
import org.biodas.jdas.schema.sources.SOURCE;

/**
 * API for a registry that provides datasources that jalview can access
 * @author jprocter
 *
 */
public interface DasSourceRegistryI
{

  List<jalviewSourceI> getSources();

  String getDasRegistryURL();

  jalviewSourceI getSource(String nickname);

  //TODO: re JAL-424 - introduce form where local source is queried for metadata, rather than have it all provided by caller.
  jalviewSourceI createLocalSource(String uri, String name, boolean sequence,
          boolean features);
  boolean removeLocalSource(jalviewSourceI source);

  void refreshSources();

  String getLocalSourceString();

  List<jalviewSourceI> resolveSourceNicknames(List<String> sources);
  // TODO: refactor to jDAS specific interface
  MultipleConnectionPropertyProviderI getSessionHandler();
}
